diff -r 11a8f1275a38 sys/netinet/tcp_output.c
--- a/sys/netinet/tcp_output.c	Mon Jul 16 20:17:19 2012 +0000
+++ b/sys/netinet/tcp_output.c	Mon Mar 11 02:59:51 2013 +1100
@@ -37,10 +37,13 @@
 #include "opt_ipsec.h"
 #include "opt_tcpdebug.h"
 
+#include <sys/endian.h>
+
 #include <sys/param.h>
 #include <sys/systm.h>
 #include <sys/domain.h>
 #include <sys/hhook.h>
+#include <sys/kdb.h>
 #include <sys/kernel.h>
 #include <sys/lock.h>
 #include <sys/mbuf.h>
@@ -49,6 +52,7 @@
 #include <sys/socket.h>
 #include <sys/socketvar.h>
 #include <sys/sysctl.h>
+#include <sys/taskqueue.h>
 
 #include <net/if.h>
 #include <net/route.h>
@@ -78,7 +82,8 @@
 #ifdef TCP_OFFLOAD
 #include <netinet/tcp_offload.h>
 #endif
-
+#include <netinet/mptcp.h>
+#include <netinet/mptcp_var.h>
 #ifdef IPSEC
 #include <netipsec/ipsec.h>
 #endif /*IPSEC*/
@@ -92,7 +97,7 @@
 	&VNET_NAME(path_mtu_discovery), 1,
 	"Enable Path MTU Discovery");
 
-VNET_DEFINE(int, tcp_do_tso) = 1;
+VNET_DEFINE(int, tcp_do_tso) = 0;
 #define	V_tcp_do_tso		VNET(tcp_do_tso)
 SYSCTL_VNET_INT(_net_inet_tcp, OID_AUTO, tso, CTLFLAG_RW,
 	&VNET_NAME(tcp_do_tso), 0,
@@ -103,29 +108,32 @@
 SYSCTL_VNET_INT(_net_inet_tcp, TCPCTL_SENDSPACE, sendspace, CTLFLAG_RW,
 	&VNET_NAME(tcp_sendspace), 0, "Initial send socket buffer size");
 
-VNET_DEFINE(int, tcp_do_autosndbuf) = 1;
-#define	V_tcp_do_autosndbuf	VNET(tcp_do_autosndbuf)
-SYSCTL_VNET_INT(_net_inet_tcp, OID_AUTO, sendbuf_auto, CTLFLAG_RW,
-	&VNET_NAME(tcp_do_autosndbuf), 0,
-	"Enable automatic send buffer sizing");
-
-VNET_DEFINE(int, tcp_autosndbuf_inc) = 8*1024;
-#define	V_tcp_autosndbuf_inc	VNET(tcp_autosndbuf_inc)
-SYSCTL_VNET_INT(_net_inet_tcp, OID_AUTO, sendbuf_inc, CTLFLAG_RW,
-	&VNET_NAME(tcp_autosndbuf_inc), 0,
-	"Incrementor step size of automatic send buffer");
-
-VNET_DEFINE(int, tcp_autosndbuf_max) = 2*1024*1024;
-#define	V_tcp_autosndbuf_max	VNET(tcp_autosndbuf_max)
-SYSCTL_VNET_INT(_net_inet_tcp, OID_AUTO, sendbuf_max, CTLFLAG_RW,
-	&VNET_NAME(tcp_autosndbuf_max), 0,
-	"Max size of automatic send buffer");
+//VNET_DEFINE(int, tcp_do_autosndbuf) = 1;
+//#define	V_tcp_do_autosndbuf	VNET(tcp_do_autosndbuf)
+//SYSCTL_VNET_INT(_net_inet_tcp, OID_AUTO, sendbuf_auto, CTLFLAG_RW,
+//	&VNET_NAME(tcp_do_autosndbuf), 0,
+//	"Enable automatic send buffer sizing");
+//
+//VNET_DEFINE(int, tcp_autosndbuf_inc) = 8*1024;
+//#define	V_tcp_autosndbuf_inc	VNET(tcp_autosndbuf_inc)
+//SYSCTL_VNET_INT(_net_inet_tcp, OID_AUTO, sendbuf_inc, CTLFLAG_RW,
+//	&VNET_NAME(tcp_autosndbuf_inc), 0,
+//	"Incrementor step size of automatic send buffer");
+//
+//VNET_DEFINE(int, tcp_autosndbuf_max) = 2*1024*1024;
+//#define	V_tcp_autosndbuf_max	VNET(tcp_autosndbuf_max)
+//SYSCTL_VNET_INT(_net_inet_tcp, OID_AUTO, sendbuf_max, CTLFLAG_RW,
+//	&VNET_NAME(tcp_autosndbuf_max), 0,
+//	"Max size of automatic send buffer");
 
 static void inline	hhook_run_tcp_est_out(struct tcpcb *tp,
 			    struct tcphdr *th, struct tcpopt *to,
 			    long len, int tso);
 static void inline	cc_after_idle(struct tcpcb *tp);
 
+static void inline 	mp_addoptions(struct tcpopt *to,
+				u_int *optlen_ptr, u_char *optp);
+
 /*
  * Wrapper for the TCP established ouput helper hook.
  */
@@ -159,6 +167,372 @@
 		CC_ALGO(tp)->after_idle(tp->ccv);
 }
 
+static void inline
+mp_addoptions(struct tcpopt *to, u_int *optlen_ptr, u_char *optp) {
+	struct mp_capable mcap;
+
+	uint64_t mask = 0;
+	for (mask = 1; mask < MPOF_MAXOPT; mask <<= 1) {
+		if ((to->to_mopts.mpo_flags & mask) != mask)
+			continue;
+		if (*optlen_ptr == TCP_MAXOLEN)
+			break;
+		switch (to->to_mopts.mpo_flags & mask)
+		{
+		case MPOF_CAPABLE_SYN:
+		{
+			/*
+			 * Note that keys are stored in network order, so
+			 * do no need to call htobe64 before bcopy
+			 */
+			mcap.kind = TCPOPT_MPTCP;
+			mcap.ver_sub = MPTCP_SUBTYPE_MP_CAPABLE;
+
+			uint8_t cap_flags = 0;
+			cap_flags |= USE_SHA1; // hard coded in sha1
+			//cap_flags |= USE_CSUM; // don't support csumming yet
+
+			if (to->to_mopts.mpo_flags & MPOF_USE_CSUM) {
+				cap_flags |= USE_CSUM;
+			}
+			/* sending a SYN */
+
+			if (TCP_MAXOLEN - *optlen_ptr < MPTCP_SUBLEN_MP_CAPABLE_SYN)
+				break;
+
+			mcap.length = MPTCP_SUBLEN_MP_CAPABLE_SYN;
+
+			/* SYN (or SYNACK), just include the local key */
+			u_int64_t key = to->to_mopts.local_key;
+
+			/* MP_CAPABLE type/flags */
+			*optlen_ptr += MPTCP_SUBLEN_MP_CAPABLE_SYN;
+			*optp++ = mcap.kind;
+			*optp++ = mcap.length;
+			*optp++ = 0; // version and subtype are 0
+			*optp++ = cap_flags;
+
+			/* copy in the key s*/
+			bcopy((u_char *)&key, optp, sizeof(key));
+			optp += sizeof(key);
+
+			/*
+			 * Indicate to caller that the capable option has been
+			 * copied into the outgoing TCP header.
+			 */
+			to->to_mopts.mpo_flags &= ~MPOF_CAPABLE_SYN;
+			break;
+		}
+		case MPOF_CAPABLE_ACK:
+		{
+			uint8_t cap_flags = 0;
+			/* ACK of 3-way handshake */
+			if (TCP_MAXOLEN - *optlen_ptr < MPTCP_SUBLEN_MP_CAPABLE_ACK)
+				break;
+
+			u_int64_t local_key = to->to_mopts.local_key;
+			u_int64_t remote_key = to->to_mopts.remote_key;
+
+			*optlen_ptr += MPTCP_SUBLEN_MP_CAPABLE_ACK;
+			*optp++ = TCPOPT_MPTCP;
+			*optp++ = MPTCP_SUBLEN_MP_CAPABLE_ACK;
+			*optp++ = 0;	// just manually setting
+			*optp++ = cap_flags;
+
+			/* and copy in the local key */
+			bcopy((u_char *)&local_key, optp, sizeof(local_key));
+			optp += sizeof(local_key);
+
+			/* echo the remote key */
+			bcopy((u_char *)&remote_key, optp, sizeof(remote_key));
+			optp += sizeof(remote_key);
+
+			break;
+		}
+		case MPOF_MP_JOIN:
+		{
+			/* Sending a MP_JOIN SYN Option */
+			if (TCP_MAXOLEN - *optlen_ptr < MPTCP_SUBLEN_MP_JOIN_SYN)
+				break;
+
+			uint8_t subtype = MPTCP_SUBTYPE_MP_JOIN;
+
+			/*
+			 * XXXNJW: just assuming for now that SYNs are sent as subflows
+			 * are added
+			 */
+			 uint8_t addrID = mp_address_count;
+
+			subtype = (subtype << 4);
+
+			*optp++ = TCPOPT_MPTCP;
+			*optp++ = MPTCP_SUBLEN_MP_JOIN_SYN;
+			*optp++ = (MPTCP_SUBTYPE_MP_JOIN << 4);	// just manually setting
+
+			*optlen_ptr += MPTCP_SUBLEN_MP_JOIN_SYN;
+			*optp++ = addrID;
+
+			to->to_mopts.rcv_token = htonl(to->to_mopts.rcv_token);
+			bcopy((u_char *)&to->to_mopts.rcv_token,
+					optp, sizeof(to->to_mopts.rcv_token));
+			optp += sizeof(to->to_mopts.rcv_token);
+
+			to->to_mopts.snd_rnd = htonl(to->to_mopts.snd_rnd);
+			bcopy((u_char *)&to->to_mopts.snd_rnd,
+					optp, sizeof(to->to_mopts.snd_rnd));
+			optp += sizeof(to->to_mopts.snd_rnd);
+
+			break;
+		}
+		case MPOF_JOIN_SYN:
+		{
+			/* Sending a MP_JOIN SYNACK Option */
+			if (TCP_MAXOLEN - *optlen_ptr < MPTCP_SUBLEN_MP_JOIN_SYNACK)
+				break;
+
+			uint8_t subtype = MPTCP_SUBTYPE_MP_JOIN;
+			subtype = (subtype << 4);
+
+			*optlen_ptr += MPTCP_SUBLEN_MP_JOIN_SYNACK;
+			*optp++ = TCPOPT_MPTCP;
+			*optp++ = MPTCP_SUBLEN_MP_JOIN_SYNACK;
+			*optp++ = subtype;
+			*optp++ = (uint8_t) to->to_mopts.addr_id;
+
+			to->to_mopts.truncated_MAC = htobe64(to->to_mopts.truncated_MAC);
+			bcopy((u_char *)&to->to_mopts.truncated_MAC,
+			    optp, sizeof(to->to_mopts.truncated_MAC));
+			optp += sizeof(to->to_mopts.truncated_MAC);
+
+			to->to_mopts.snd_rnd = htonl(to->to_mopts.snd_rnd);
+			bcopy((u_char *)&to->to_mopts.snd_rnd,
+			    optp, sizeof(to->to_mopts.snd_rnd));
+			optp += sizeof(to->to_mopts.snd_rnd);
+			break;
+		}
+		case MPOF_JOIN_SYNACK:
+		{
+			/* Sending a MP_JOIN ACK Option */
+			if (TCP_MAXOLEN - *optlen_ptr < MPTCP_SUBLEN_MP_JOIN_ACK) {
+				break;
+			}
+
+			uint8_t subtype = MPTCP_SUBTYPE_MP_JOIN;
+			subtype = (subtype << 4);
+
+			*optlen_ptr += (uint8_t) MPTCP_SUBLEN_MP_JOIN_ACK;
+			*optp++ = TCPOPT_MPTCP;
+			*optp++ = MPTCP_SUBLEN_MP_JOIN_ACK;
+			*optp++ = subtype;
+			/* the last 12-bits after subtype are reserved (zeroed) */
+			*optp++ = 0;
+
+			uint32_t tempval = 0;
+			bcopy((u_char *)&tempval,
+					optp, sizeof(tempval));
+			optp += sizeof(tempval);
+
+			uint64_t tempval2 = 0;
+			bcopy((u_char *)&tempval2,
+					optp, sizeof(tempval2));
+			optp += sizeof(tempval2);
+
+			bcopy((u_char *)&tempval2,
+					optp, sizeof(tempval2));
+			optp += sizeof(tempval2);
+			break;
+		}
+		case MPOF_DSS:
+		{
+			uint8_t subtype = MPTCP_SUBTYPE_DSS;
+			uint8_t dss_opts = 0;
+			uint8_t length = 4; /* the initial 4 bytes of option */
+
+			/* Set flags for DSS */
+	//		if (to->to_mopts.mpo_flags & MPOF_DATA_FIN) {
+	//			printf("adding Data-fin\n");
+	//			dss_opts |= FIN_PRESENT;
+	//		}
+
+			if (to->to_mopts.mpo_flags & MPOF_DATA_ACK) {
+				dss_opts |= ACK_PRESENT;
+				length += 4;
+
+				if (to->to_mopts.mpo_flags & MPOF_ACK64) {
+					dss_opts |= ACK_64_PRESENT;
+					length += 4;
+				}
+			}
+
+			if (to->to_mopts.mpo_flags & MPOF_DSN_MAP) {
+				dss_opts |= MAP_PRESENT;
+				length += 4;
+
+				length += 4;	/* subflow sequence num */
+				length += 2;	/* data length */
+
+				if(to->to_mopts.mpo_flags & MPOF_USE_CSUM)
+					length += 2;
+
+				if (to->to_mopts.mpo_flags & MPOF_DSN64) {
+					length += 4;
+					dss_opts |= DSN_64;
+				}
+			}
+
+			if (TCP_MAXOLEN - *optlen_ptr < length)
+				break;
+
+			*optlen_ptr += length;
+
+			// pad it out to divide by 4 to prevent EOL being inserted before our option
+			// XXX kind of a hack, to fix
+			if (*optlen_ptr % 4) {
+				*optlen_ptr += TCPOLEN_NOP;
+				*optp++ = TCPOPT_NOP;
+				*optlen_ptr += TCPOLEN_NOP;
+				*optp++ = TCPOPT_NOP;
+			}
+
+			/* option kind and length fields */
+			*optp++ = TCPOPT_MPTCP;
+			*optp++ = length;
+
+			/* subtype and flags */
+			subtype = (subtype << 4);
+			bcopy((u_char *)&subtype, optp, sizeof(uint8_t));
+			optp += sizeof(uint8_t);
+			to->to_mopts.dss_opts_f_p = (uint8_t*) optp;
+			bcopy((u_char *)&dss_opts, optp, sizeof(uint8_t));
+			optp += sizeof(uint8_t);
+
+			/* copy the Data ACK */
+			if (to->to_mopts.mpo_flags & MPOF_DATA_ACK) {
+				if (to->to_mopts.mpo_flags & MPOF_ACK64) {
+					u_int64_t data_ack_num = to->to_mopts.data_ack_num;
+					data_ack_num = htobe64(data_ack_num);
+					bcopy((u_char *)&data_ack_num, optp, sizeof(data_ack_num));
+					optp += sizeof(data_ack_num);
+				} else {
+					u_int32_t data_ack_num = (uint32_t) to->to_mopts.data_ack_num;
+					data_ack_num = htonl(data_ack_num);
+					bcopy((u_char *)&data_ack_num, optp, sizeof(data_ack_num));
+					optp += sizeof(data_ack_num);
+				}
+			}
+
+			/* DSN contents */
+			if (to->to_mopts.mpo_flags & MPOF_DSN_MAP) {
+				uint32_t data_seq_num = (uint32_t) to->to_mopts.data_seq_num;
+				/* DSN and SSN */
+				if (to->to_mopts.mpo_flags & MPOF_DSN64) {
+					to->to_mopts.data_seq_num =
+							htobe64(to->to_mopts.data_seq_num);
+					bcopy((u_char *)&to->to_mopts.data_seq_num,
+							optp, sizeof(to->to_mopts.data_seq_num));
+					optp += sizeof(to->to_mopts.data_seq_num);
+				} else {
+					data_seq_num = htonl(data_seq_num);
+					bcopy((u_char *)&data_seq_num, optp, sizeof(data_seq_num));
+					optp += sizeof(data_seq_num);
+				}
+
+				to->to_mopts.sub_seq_num = htonl(to->to_mopts.sub_seq_num);
+				bcopy((u_char *)&to->to_mopts.sub_seq_num, optp,
+					sizeof(to->to_mopts.sub_seq_num));
+				optp += sizeof(to->to_mopts.sub_seq_num);
+
+				/* Length */
+				to->to_mopts.dss_data_len = htons(to->to_mopts.dss_data_len);
+				bcopy((u_char *)&to->to_mopts.dss_data_len, optp,
+					sizeof(to->to_mopts.dss_data_len));
+				optp += sizeof(to->to_mopts.dss_data_len);
+
+				if(to->to_mopts.mpo_flags & MPOF_USE_CSUM) {
+					to->to_mopts.dss_csum = htons(to->to_mopts.dss_csum);
+					bcopy((u_char *)&to->to_mopts.dss_csum, optp,
+						sizeof(to->to_mopts.dss_csum));
+					optp += sizeof(to->to_mopts.dss_csum);
+				}
+			}
+
+			/*
+			 * We process both at once so can clear flags to prevent
+			 * processing twice.
+			 */
+			to->to_mopts.mpo_flags &= ~MPOF_DSN_MAP;
+			to->to_mopts.mpo_flags &= ~MPOF_DATA_ACK;
+			break;
+		}
+		case MPOF_ADD_ADDR:
+		{
+			struct mp_add address;
+			int i, addr_len = 0;
+			void * addr = NULL;
+
+			address.length = address.sub_ipver = 0;
+
+			/* The list of addresses should be locked at this point. */
+			/* Loop through the available addresses. */
+			for (i = 0; i < mp_address_count; i++) {
+				/* continue if there are addresses to advertise */
+				if (!(to->to_mopts.add_addr_mask & (1 << i)))
+					continue;
+
+				switch (mp_usable_addresses[i].ss_family) {
+					case AF_INET:
+						addr = &((struct sockaddr_in *)
+							&mp_usable_addresses[i])->sin_addr.s_addr;
+						address.length = MPTCP_SUBLEN_ADD_ADDRV4;
+						address.sub_ipver = 4;
+						addr_len = 4;
+						break;
+					case AF_INET6:
+						addr = &((struct sockaddr_in6 *)
+							&mp_usable_addresses[i])->sin6_addr.__u6_addr;
+						address.length = MPTCP_SUBLEN_ADD_ADDRV6;
+						address.sub_ipver = 6;
+						addr_len = 16;
+						break;
+				}
+
+				if (TCP_MAXOLEN - *optlen_ptr < address.length)
+					break;
+
+				/* mark address as advertised. Need to pass this back to  */
+				to->to_mopts.add_addr_mask &= ~(1 << i);
+
+				*optlen_ptr += address.length;
+				*optp++ = TCPOPT_MPTCP;
+				*optp++ = address.length;
+
+				/* subtype and IPVer */
+				uint8_t subtype = (MPTCP_SUBTYPE_ADD_ADDR << 4);
+				subtype |= address.sub_ipver;
+				bcopy((u_char *)&subtype, optp, sizeof(uint8_t));
+				optp ++;
+
+				/* Address ID */
+				bcopy((u_char *)&i, optp, sizeof(uint8_t));
+				optp ++;
+
+				bcopy((u_char *)addr, optp, addr_len);
+				optp += addr_len;
+			}
+			break;
+		}
+		case MPOF_REMOVE_ADDR:
+			break;
+		case MPOF_MP_FAIL:
+			break;
+		case MPOF_FASTCLOSE:
+			break;
+		default:
+			break;
+		}
+	}
+}
+
 /*
  * Tcp output routine: figure out what should be sent and send it.
  */
@@ -167,7 +541,8 @@
 {
 	struct socket *so = tp->t_inpcb->inp_socket;
 	long len, recwin, sendwin;
-	int off, flags, error = 0;	/* Keep compiler happy */
+	int off = 0, flags, map_unsent, error = 0;	/* Keep compiler happy */
+	struct ds_map *snd_dsmap;
 	struct mbuf *m;
 	struct ip *ip = NULL;
 	struct ipovly *ipov = NULL;
@@ -199,6 +574,7 @@
 		return (tcp_offload_output(tp));
 #endif
 
+
 	/*
 	 * Determine length of data that should be transmitted,
 	 * and flags that will be used.
@@ -227,10 +603,9 @@
 	sendalot = 0;
 	tso = 0;
 	mtu = 0;
-	off = tp->snd_nxt - tp->snd_una;
 	sendwin = min(tp->snd_wnd, tp->snd_cwnd);
+	flags = tcp_outflags[tp->t_state];
 
-	flags = tcp_outflags[tp->t_state];
 	/*
 	 * Send any SACK-generated retransmissions.  If we're explicitly trying
 	 * to send out new data (when sendalot is 1), bypass this function.
@@ -238,6 +613,7 @@
 	 * we're replacing a (future) new transmission with a retransmission
 	 * now, and we previously incremented snd_cwnd in tcp_input().
 	 */
+
 	/*
 	 * Still in sack recovery , reset rxmit flag to zero.
 	 */
@@ -248,7 +624,7 @@
 	if ((tp->t_flags & TF_SACK_PERMIT) && IN_FASTRECOVERY(tp->t_flags) &&
 	    (p = tcp_sack_output(tp, &sack_bytes_rxmt))) {
 		long cwin;
-		
+
 		cwin = min(tp->snd_wnd, tp->snd_cwnd) - sack_bytes_rxmt;
 		if (cwin < 0)
 			cwin = 0;
@@ -267,6 +643,7 @@
 				 * moves past p->rxmit.
 				 */
 				p = NULL;
+				tp->snd_nxt = tp->snd_max;			//XXX experimenting
 				goto after_sack_rexmit;
 			} else
 				/* Can rexmit part of the current hole */
@@ -274,15 +651,19 @@
 						   tp->snd_recover - p->rxmit));
 		} else
 			len = ((long)ulmin(cwin, p->end - p->rxmit));
-		off = p->rxmit - tp->snd_una;
+		//off = p->rxmit - tp->snd_una;
+
 		KASSERT(off >= 0,("%s: sack block to the left of una : %d",
 		    __func__, off));
 		if (len > 0) {
+			tp->snd_nxt = p->rxmit;					//XXX experimenting
 			sack_rxmit = 1;
 			sendalot = 1;
 			TCPSTAT_INC(tcps_sack_rexmits);
 			TCPSTAT_ADD(tcps_sack_rexmit_bytes,
 			    min(len, tp->t_maxseg));
+		} else {
+			tp->snd_nxt = tp->snd_max;
 		}
 	}
 after_sack_rexmit:
@@ -295,7 +676,24 @@
 	if (tp->t_flags & TF_NEEDSYN)
 		flags |= TH_SYN;
 
-	SOCKBUF_LOCK(&so->so_snd);
+	off = tp->snd_nxt - tp->snd_una;
+
+	if((flags & TH_FIN && tp->snd_nxt == tp->snd_max)
+	    || tp->t_state >= TCPS_FIN_WAIT_1
+	    || (!IS_MASTER_TP(tp) && !tp->mp_active))	//XXX test to prevent maps from being added once application has issued a close
+		snd_dsmap = NULL;
+	else
+		snd_dsmap = mp_find_dsmap(tp, tp->snd_nxt);
+
+	if (snd_dsmap) {
+		off -= snd_dsmap->sf_seq_start - tp->snd_una;
+		 map_unsent = TAILQ_FIRST(&tp->t_txdsmaps)->sf_seq_start
+			+ TAILQ_FIRST(&tp->t_txdsmaps)->ds_map_len
+			- tp->snd_max;
+	} else {
+		map_unsent = 0;
+	}
+
 	/*
 	 * If in persist timeout with window of 0, send 1 byte.
 	 * Otherwise, if window is small but nonzero
@@ -320,7 +718,8 @@
 			 * to send then the probe will be the FIN
 			 * itself.
 			 */
-			if (off < so->so_snd.sb_cc)
+			if ((off < snd_dsmap->ds_map_len) && snd_dsmap ==
+				TAILQ_FIRST(&tp->t_txdsmaps))
 				flags &= ~TH_FIN;
 			sendwin = 1;
 		} else {
@@ -346,27 +745,26 @@
 	 */
 	if (sack_rxmit == 0) {
 		if (sack_bytes_rxmt == 0)
-			len = ((long)ulmin(so->so_snd.sb_cc, sendwin) - off);
+			len = (long)ulmin(map_unsent, sendwin);
 		else {
 			long cwin;
 
-                        /*
+             /*
 			 * We are inside of a SACK recovery episode and are
 			 * sending new data, having retransmitted all the
 			 * data possible in the scoreboard.
 			 */
-			len = ((long)ulmin(so->so_snd.sb_cc, tp->snd_wnd) 
-			       - off);
+			len = (long)ulmin(map_unsent, tp->snd_wnd);
 			/*
 			 * Don't remove this (len > 0) check !
-			 * We explicitly check for len > 0 here (although it 
-			 * isn't really necessary), to work around a gcc 
+			 * We explicitly check for len > 0 here (although it
+			 * isn't really necessary), to work around a gcc
 			 * optimization issue - to force gcc to compute
 			 * len above. Without this check, the computation
 			 * of len is bungled by the optimizer.
 			 */
 			if (len > 0) {
-				cwin = tp->snd_cwnd - 
+				cwin = tp->snd_cwnd -
 					(tp->snd_nxt - tp->sack_newdata) -
 					sack_bytes_rxmt;
 				if (cwin < 0)
@@ -392,7 +790,8 @@
 	 * This measure is needed to prevent interoperability problems
 	 * with not fully conformant TCP implementations.
 	 */
-	if ((flags & TH_SYN) && (tp->t_flags & TF_NOOPT)) {
+	if (((flags & TH_SYN) && (tp->t_flags & TF_NOOPT))
+			|| (tp->t_mpcb->mp_flags & MPO_GOTJOINSYNACK)) {
 		len = 0;
 		flags &= ~TH_FIN;
 	}
@@ -421,6 +820,9 @@
 	/* len will be >= 0 after this point. */
 	KASSERT(len >= 0, ("[%s:%d]: len < 0", __func__, __LINE__));
 
+	if (len)
+		KASSERT(snd_dsmap != NULL, ("%s: Segment has length but no send map\n", __func__));
+
 	/*
 	 * Automatic sizing of send socket buffer.  Often the send buffer
 	 * size is not optimally adjusted to the actual network conditions
@@ -456,17 +858,18 @@
 	 * with congestion window.  Requires another timer.  Has to
 	 * wait for upcoming tcp timer rewrite.
 	 */
-	if (V_tcp_do_autosndbuf && so->so_snd.sb_flags & SB_AUTOSIZE) {
-		if ((tp->snd_wnd / 4 * 5) >= so->so_snd.sb_hiwat &&
-		    so->so_snd.sb_cc >= (so->so_snd.sb_hiwat / 8 * 7) &&
-		    so->so_snd.sb_cc < V_tcp_autosndbuf_max &&
-		    sendwin >= (so->so_snd.sb_cc - (tp->snd_nxt - tp->snd_una))) {
-			if (!sbreserve_locked(&so->so_snd,
-			    min(so->so_snd.sb_hiwat + V_tcp_autosndbuf_inc,
-			     V_tcp_autosndbuf_max), so, curthread))
-				so->so_snd.sb_flags &= ~SB_AUTOSIZE;
-		}
-	}
+	//XXXNJW: To move into scheduler or elsewhere
+//	if (V_tcp_do_autosndbuf && (so->so_snd.sb_flags & SB_AUTOSIZE)) {
+//		if ((tp->snd_wnd / 4 * 5) >= so->so_snd.sb_hiwat &&
+//			so->so_snd.sb_cc >= (so->so_snd.sb_hiwat / 8 * 7) &&
+//			so->so_snd.sb_cc < V_tcp_autosndbuf_max &&
+//			sendwin >= (so->so_snd.sb_cc - (tp->snd_nxt - tp->snd_una))) {
+//			if (!sbreserve_locked(&so->so_snd,
+//				min(so->so_snd.sb_hiwat + V_tcp_autosndbuf_inc,
+//				 V_tcp_autosndbuf_max), so, curthread))
+//				so->so_snd.sb_flags &= ~SB_AUTOSIZE;
+//		}
+//	}
 
 	/*
 	 * Decide if we can use TCP Segmentation Offloading (if supported by
@@ -496,15 +899,21 @@
 	    tp->t_inpcb->in6p_options == NULL)
 		tso = 1;
 
+	//XXXNJW: snd_max or snd_max-1?
 	if (sack_rxmit) {
-		if (SEQ_LT(p->rxmit + len, tp->snd_una + so->so_snd.sb_cc))
+		if (SEQ_LT(p->rxmit + len, tp->snd_max))
 			flags &= ~TH_FIN;
 	} else {
-		if (SEQ_LT(tp->snd_nxt + len, tp->snd_una + so->so_snd.sb_cc))
+		if (SEQ_LT(tp->snd_nxt + len, tp->snd_max))
 			flags &= ~TH_FIN;
 	}
 
-	recwin = sbspace(&so->so_rcv);
+	// XXXNJW: Call into mp layer to get the receive window size we want
+	// to advertise. currently does nothing and we just set recwin to
+	// the max window we can advertise (as there is no bound on the
+	// size of the receive buffer).
+	recwin = (long)TCP_MAXWIN << tp->rcv_scale;
+	mp_get_recwin(&recwin);
 
 	/*
 	 * Sender silly window avoidance.   We transmit under the following
@@ -525,12 +934,9 @@
 		 * NOTE! on localhost connections an 'ack' from the remote
 		 * end may occur synchronously with the output and cause
 		 * us to flush a buffer queued with moretocome.  XXX
-		 *
-		 * note: the len + off check is almost certainly unnecessary.
 		 */
 		if (!(tp->t_flags & TF_MORETOCOME) &&	/* normal case */
 		    (idle || (tp->t_flags & TF_NODELAY)) &&
-		    len + off >= so->so_snd.sb_cc &&
 		    (tp->t_flags & TF_NOPUSH) == 0) {
 			goto send;
 		}
@@ -579,8 +985,9 @@
 			goto dontupdate;
 		if (adv >= (long) (2 * tp->t_maxseg))
 			goto send;
-		if (2 * adv >= (long) so->so_rcv.sb_hiwat)
-			goto send;
+		//XXX To be removed (next merge with head will take care of this)
+		//if (2 * adv >= (long) so->so_rcv.sb_hiwat)
+		//	goto send;
 	}
 dontupdate:
 
@@ -636,7 +1043,7 @@
 	 * if window is nonzero, transmit what we can,
 	 * otherwise force out a byte.
 	 */
-	if (so->so_snd.sb_cc && !tcp_timer_active(tp, TT_REXMT) &&
+	if (map_unsent && !tcp_timer_active(tp, TT_REXMT) &&
 	    !tcp_timer_active(tp, TT_PERSIST)) {
 		tp->t_rxtshift = 0;
 		tcp_setpersist(tp);
@@ -646,11 +1053,9 @@
 	 * No reason to send a segment, just return.
 	 */
 just_return:
-	SOCKBUF_UNLOCK(&so->so_snd);
 	return (0);
 
 send:
-	SOCKBUF_LOCK_ASSERT(&so->so_snd);
 	/*
 	 * Before ESTABLISHED, force sending of initial options
 	 * unless TCP set not to do any options.
@@ -675,6 +1080,8 @@
 	 */
 	if ((tp->t_flags & TF_NOOPT) == 0) {
 		to.to_flags = 0;
+		to.to_mopts.mpo_flags = 0;
+
 		/* Maximum segment size. */
 		if (flags & TH_SYN) {
 			tp->snd_nxt = tp->iss;
@@ -686,6 +1093,147 @@
 			to.to_wscale = tp->request_r_scale;
 			to.to_flags |= TOF_SCALE;
 		}
+
+		if (tp->mp_enabled) {
+			/*
+			 * If SYN and mp_enabled, should check if this is the initial
+			 * connection attempt on the master subflow. The master subflow
+			 * should have an MP_CAPABLE option, while a subflow will have
+			 * an MP_JOIN option
+			 */
+			if (flags & TH_SYN) {
+				/* Multipath announce capable, for SYN and SYN/ACK */
+				if (IS_MASTER_TP(tp)) {
+					tp->sent_capable = 1;
+
+					to.to_flags |= TOF_MPTCP;
+					to.to_mopts.mpo_flags |= MPOF_CAPABLE_SYN;
+
+					to.to_mopts.local_key =
+							tp->t_mpcb->local_key;
+					//if (tp->t_mpcb->mp_status & CSUM_ENABLED)
+						//to.to_mopts.mpo_flags |= MPOF_USE_CSUM;
+				} else {
+					/* A SYN on a subflow that isn't the master, use MP_JOIN */
+					tp->sent_capable = 1;
+					tp->mpc = 1;
+					to.to_flags |= TOF_MPTCP;
+					to.to_mopts.mpo_flags |= MPOF_MP_JOIN;
+					to.to_mopts.rcv_token =
+							tp->t_mpcb->remote_token;
+					to.to_mopts.snd_rnd = arc4random();
+					to.to_mopts.addr_id = tp->t_mpcb->subflow_cnt - 1;
+					tp->local_rand = to.to_mopts.snd_rnd;
+				}
+			}
+
+			/* received a SYNACK with MP_CAPABLE */
+			if (tp->sf_flags & SFF_GOT_SYNACK) {
+				tp->sf_flags &= ~SFF_GOT_SYNACK;
+				/* got a synack after sending capable */
+
+				if (tp->sent_capable) {
+					to.to_flags |= TOF_MPTCP;
+					to.to_mopts.mpo_flags |= MPOF_CAPABLE_ACK;
+					to.to_mopts.local_key =
+							tp->t_mpcb->local_key;
+					to.to_mopts.remote_key =
+							tp->t_mpcb->remote_key;
+
+				}
+			}
+
+			/* Received a SYNACK with MP_JOIN */
+			if (tp->sf_flags & SFF_GOT_JOIN_SYNACK) {
+				/* XXX: should clear this only when we know that the
+				 * option has been copied into a packet.
+				 */
+				tp->sf_flags &= ~SFF_GOT_JOIN_SYNACK;
+
+				/* XXX: Should set this state only when we know the
+				 * option has been put into packet */
+				tp->sf_state = MPS_PRE_ESTABLISHED;
+
+				/* Add an MP_JOIN_ACK to the outgoing packet */
+				to.to_flags |= TOF_MPTCP;
+				to.to_mopts.mpo_flags |= MPOF_JOIN_SYNACK;
+			}
+		}
+			/* do these options only once mptcp is established */
+		if ((tp->mp_active == 1) &&
+		    (tp->t_mpcb->mp_state >= MPS_ESTABLISHED)) {
+			
+			/*
+			 * Need to add an ADD_ADDR on the next outgoing packet if asked to
+			 * or if all available addresses have not yet been advertised
+			 */
+			if (tp->t_mpcb->mp_advaddr_mask) {
+				to.to_flags |= TOF_MPTCP;
+				to.to_mopts.mpo_flags |= MPOF_ADD_ADDR;
+				to.to_mopts.add_addr_mask = tp->t_mpcb->mp_advaddr_mask;
+			}
+
+			/*
+			 * Need to attach a DATA-ACK to the outgoing packet
+			 * MPO_DATA_ACK is set in tcp_reass when in-order
+			 * data segments are provided to the process. currently
+			 * this works like an ACK_NOW, and will be put onto any
+			 * outgoing segment.
+			 *
+			 * XXX: provide a callout to do time-delayed Data-ACKs
+			 */
+
+			if (tp->t_mpcb->mp_flags & MPO_DATA_ACK) {
+				tp->t_mpcb->mp_flags &= ~MPO_DATA_ACK;
+				to.to_flags |= TOF_MPTCP;
+				to.to_mopts.mpo_flags |= MPOF_DATA_ACK;
+				to.to_mopts.mpo_flags |= MPOF_DSS;
+				//to.to_mopts.mpo_flags |= MPOF_ACK64;				// should check against session settings
+				to.to_mopts.data_ack_num =
+						(uint32_t) tp->t_mpcb->ds_rcv_nxt;
+			}
+
+			// XXXNJW: hack testing solution to put DSS on each packet with length
+			// Maps to be provided elsewhere, perhaps using the scheduler?
+//			if (len && tp->mp_active)
+
+			// Only put a map on the first packet
+			if (off == 0 && len)
+				to.to_mopts.mpo_flags |= MPOF_DSN_MAP;
+
+			/* need to build a DSS MAP for the outgoing packet */
+			if (to.to_mopts.mpo_flags & MPOF_DSN_MAP) {
+				/* XXXNJW: implement checks for csum and dsn64 */
+				//to.to_mopts.mpo_flags |= MPOF_USE_CSUM; //XXX: temp
+				//to.to_mopts.mpo_flags |= MPOF_DSN64;	//XXX: temp
+
+				to.to_flags |= TOF_MPTCP;
+				to.to_mopts.mpo_flags |= MPOF_DSS;
+
+				// build map here.
+				// 32-bit values are copied in add_options
+				//XXX wrapping?
+				to.to_mopts.sub_seq_num = (snd_dsmap->sf_seq_start - tp->iss);
+
+				//XXXNJW detect wrapping
+				to.to_mopts.data_seq_num = (uint32_t) snd_dsmap->ds_map_start;
+
+				to.to_mopts.dss_data_len = snd_dsmap->ds_map_len;
+
+				/* received a SYNACK with MP_JOIN */
+				if (tp->t_mpcb->mp_flags & MPO_GOTJOINSYNACK) {
+					tp->t_mpcb->mp_flags &= ~MPO_GOTJOINSYNACK;
+					/* got a synack after sending capable */
+
+					to.to_flags |= TOF_MPTCP;
+					to.to_mopts.mpo_flags |= MPOF_JOIN_ACK;
+
+				// would also add the MAC/nonce here.
+				}
+
+			}
+		}
+
 		/* Timestamps. */
 		if ((tp->t_flags & TF_RCVD_TSTMP) ||
 		    ((flags & TH_SYN) && (tp->t_flags & TF_REQ_TSTMP))) {
@@ -719,6 +1267,13 @@
 		hdrlen += optlen = tcp_addoptions(&to, opt);
 	}
 
+	/* update the address masks */
+	if (to.to_mopts.mpo_flags & MPOF_ADD_ADDR) {
+		to.to_mopts.mpo_flags &= ~MPOF_ADD_ADDR;
+		tp->t_mpcb->mp_advaddr_mask = to.to_mopts.add_addr_mask;
+		taskqueue_enqueue(taskqueue_swi, &tp->t_mpcb->join_task);
+	}
+
 #ifdef INET6
 	if (isipv6)
 		ipoptlen = ip6_optlen(tp->t_inpcb);
@@ -733,6 +1288,7 @@
 	ipoptlen += ipsec_optlen;
 #endif
 
+
 	/*
 	 * Adjust data length if insertion of options will
 	 * bump the packet length beyond the t_maxopd length.
@@ -761,7 +1317,7 @@
 			 * fractional unless the send sockbuf can
 			 * be emptied.
 			 */
-			if (sendalot && off + len < so->so_snd.sb_cc) {
+			if (sendalot && off + len < map_unsent) {
 				len -= len % (tp->t_maxopd - optlen);
 				sendalot = 1;
 			}
@@ -807,9 +1363,6 @@
 	 * the template for sends on this connection.
 	 */
 	if (len) {
-		struct mbuf *mb;
-		u_int moff;
-
 		if ((tp->t_flags & TF_FORCEDATA) && len == 1)
 			TCPSTAT_INC(tcps_sndprobe);
 		else if (SEQ_LT(tp->snd_nxt, tp->snd_max) || sack_rxmit) {
@@ -822,7 +1375,6 @@
 		}
 		MGETHDR(m, M_DONTWAIT, MT_DATA);
 		if (m == NULL) {
-			SOCKBUF_UNLOCK(&so->so_snd);
 			error = ENOBUFS;
 			goto out;
 		}
@@ -830,7 +1382,6 @@
 		if (MHLEN < hdrlen + max_linkhdr) {
 			MCLGET(m, M_DONTWAIT);
 			if ((m->m_flags & M_EXT) == 0) {
-				SOCKBUF_UNLOCK(&so->so_snd);
 				m_freem(m);
 				error = ENOBUFS;
 				goto out;
@@ -841,19 +1392,16 @@
 		m->m_len = hdrlen;
 
 		/*
-		 * Start the m_copy functions from the closest mbuf
-		 * to the offset in the socket buffer chain.
+		 * Start the m_copy functions from the map's mbuf_start mbuf.
 		 */
-		mb = sbsndptr(&so->so_snd, off, len, &moff);
-
 		if (len <= MHLEN - hdrlen - max_linkhdr) {
-			m_copydata(mb, moff, (int)len,
-			    mtod(m, caddr_t) + hdrlen);
+			m_copydata(snd_dsmap->mbuf_start, snd_dsmap->mbuf_offset + off,
+			    (int)len, mtod(m, caddr_t) + hdrlen);
 			m->m_len += len;
 		} else {
-			m->m_next = m_copy(mb, moff, (int)len);
+			m->m_next = m_copy(snd_dsmap->mbuf_start,
+				snd_dsmap->mbuf_offset + off, (int)len);
 			if (m->m_next == NULL) {
-				SOCKBUF_UNLOCK(&so->so_snd);
 				(void) m_free(m);
 				error = ENOBUFS;
 				goto out;
@@ -861,16 +1409,39 @@
 		}
 
 		/*
+		 * Complete sending data from the current map. Can allocate a new map
+		 * if there is more data available to send in the send buffer.
+		 */
+		if (off + len >= snd_dsmap->ds_map_len) {
+			snd_dsmap->flags |= MAPF_IS_SENT;
+			mp_debug(DSMAP, 4, 0, "%s: Marked snd_dsmap %p as SENT, map_len: %d, mbuf_start: %p, sf_seq_start: %u\n",
+				__func__, snd_dsmap, snd_dsmap->ds_map_len,
+				snd_dsmap->mbuf_start, snd_dsmap->sf_seq_start);
+			if(tp->t_flags & TF_NEEDFIN &&
+			    snd_dsmap->sf_seq_start + snd_dsmap->ds_map_len == tp->snd_max) // send max + len?
+				snd_dsmap = NULL;
+			else
+				snd_dsmap = mp_find_dsmap(tp, snd_dsmap->sf_seq_start + snd_dsmap->ds_map_len);
+
+			if (snd_dsmap != NULL)
+				map_unsent = snd_dsmap->ds_map_len;
+			else
+				map_unsent = 0;
+		}
+
+		/*
 		 * If we're sending everything we've got, set PUSH.
 		 * (This will keep happy those implementations which only
 		 * give data to the user when a buffer fills or
 		 * a PUSH comes in.)
 		 */
-		if (off + len == so->so_snd.sb_cc)
+		/* Finished sending previous map and could not get more bytes
+		 * for this subflow */
+		if (map_unsent == 0) {
 			flags |= TH_PUSH;
-		SOCKBUF_UNLOCK(&so->so_snd);
+
+		}
 	} else {
-		SOCKBUF_UNLOCK(&so->so_snd);
 		if (tp->t_flags & TF_ACKNOW)
 			TCPSTAT_INC(tcps_sndacks);
 		else if (flags & (TH_SYN|TH_FIN|TH_RST))
@@ -894,7 +1465,6 @@
 		m->m_data += max_linkhdr;
 		m->m_len = hdrlen;
 	}
-	SOCKBUF_UNLOCK_ASSERT(&so->so_snd);
 	m->m_pkthdr.rcvif = (struct ifnet *)0;
 #ifdef MAC
 	mac_inpcb_create_mbuf(tp->t_inpcb, m);
@@ -921,6 +1491,7 @@
 	if (flags & TH_FIN && tp->t_flags & TF_SENTFIN &&
 	    tp->snd_nxt == tp->snd_max)
 		tp->snd_nxt--;
+
 	/*
 	 * If we are starting a connection, send ECN setup
 	 * SYN packet. If we are on a retransmit, we may
